'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var server = require('@shopify/react-effect/server');
var assets = require('./context/assets.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

async function getUsedAssets(element, ...args) {
  const asyncAssets = new assets.AsyncAssetManager();
  await server.extract(element, {
    decorate: element => /*#__PURE__*/React__default["default"].createElement(assets.AsyncAssetContext.Provider, {
      value: asyncAssets
    }, element)
  });
  return asyncAssets.used(...args);
}

exports.getUsedAssets = getUsedAssets;
